Subject: RE: PPP protocol field compression

From: Bonnie Hutchings <[email-masked]>
Date: Wed, 24 May 2000 10:41:09 -0700

If example 1 is correct, it raises another question.  Since 0x00cf is a
valid value for the Protocol field, and compressed it is indistinguishable
from the NLPID, how can intermediate forwarding devices, which are not privy
to the configuration options selected for the link, distinguish between a
compressed vs an uncompressed frame?  It looks to me as though they can't.
Is that true?

Thanks,
Bonnie

> -----Original Message-----
> From: Archie Cobbs [mailto:[email-masked]]
> Sent: Wednesday, May 24, 2000 10:15 AM
> To: [email-masked]
> Cc: [email-masked]
> Subject: Re: PPP protocol field compression
> 
> 
> Bonnie Hutchings writes:
> > So does a protocol-compressed frame look like this (call it 
> example 1)?:
> > 
> >     0                   1                   2                   3
> >     0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1
> >    +-+-+-+-+-+-+-+-+
> >    |  Flag (0x7e)  |
> >    +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
> >    |         Q.922 Address         |    Control    |  PPP Protocol |
> >    +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
> >   
> > Or does it look like this (example 2):
> >  
> >     0                   1                   2                   3
> >     0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1
> >    +-+-+-+-+-+-+-+-+
> >    |  Flag (0x7e)  |
> >    +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
> >    |         Q.922 Address         |    Control    |  NLPID(0xcf)  |
> >    +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
> >    | PPP Protocol  |
> >    +-+-+-+-+-+-+-+-+
> > 
> > Example 1 seems to conform to 'the NLPID is removed and the 
> Protocol field
> > is compressed to a single octet', but not to 'Alignment to a 32-bit
> > boundary' whereas in Example 2, the NLPID has not been 
> removed, but the PPP
> > payload is 32-bit aligned.   Can anyone clarify this for me?
> 
> I believe example 1 is what is intended. Example 1 *is* aligned to
> a 32-bit boundary: there are four data bytes. The "flag byte" is
> not really a byte, but a repeated bit pattern on the synchronous
> line for which there is no "alignment" because there is no data...
> it's just inter-frame fill. The Q.922 address is the beginning of
> the data.
> 
> -Archie
> 
> ______________________________________________________________
> _____________
> Archie Cobbs   *   Whistle Communications, Inc.  *   
> http://www.whistle.com
>

---

From: Archie Cobbs <[email-masked]>
Date: Wed, 24 May 2000 10:45:15 -0700 (PDT)

> compressed vs an uncompressed frame?  It looks to me as though they can't.

Why would they care? If they see 0x00cf, it's a PPP frame no matter what.

In addition, from the RFC:

  Currently, there are no conflicts between NLPID and PPP Protocol
  values.  If a future implementation is configured to send a NLPID
  value which is the same as a compressed Protocol field, that Protocol
  field MUST NOT be sent compressed.

-Archie

___________________________________________________________________________
Archie Cobbs   *   Whistle Communications, Inc.  *   http://www.whistle.com